package com.fri.http.framework.resources;

import com.fri.http.framework.config.YXDefaultServerConfig;
import com.fri.http.framework.logging.YXLogging;
import com.fri.http.legalchapter.rzfw.auth.AuthApply;
import com.fri.http.legalchapter.rzfw.auth.AuthRequest;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.ws.rs.*;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;
import java.util.logging.Logger;


/**
 * Created by lixiaoyang on 4/27/17.
 * 版本
 * v1.0/auth_app
 * v1.0/authen_req
 */
@Path("v2.0")
public class CTIDRestResources {

    private Logger logger = YXLogging.getLogger(YXDefaultServerConfig.LOGGING_NAME_REQUEST_SERVER);


    @POST
    @Path("auth_app")
    @Consumes(MediaType.APPLICATION_JSON)
    @Produces(MediaType.APPLICATION_JSON)
    /**
     * 认证申请
     * 接收带有 JSON Body 的POST请求，非Form模式
     */
    public String authAppForward(String jsonStr, @Context HttpServletRequest req, @Context HttpServletResponse resp) throws Exception {
        resp.setCharacterEncoding("UTF-8");
        String response=new AuthApply().authApplyExecute(jsonStr);
        System.out.println("一包响应给客户端结果"+response);
        return response;
    }

    @POST
    @Path("authen_req")
    @Consumes(MediaType.APPLICATION_JSON)
    @Produces(MediaType.APPLICATION_JSON)
    /**
     * 认证请求
     * 接收带有 JSON Body 的POST请求，非Form模式
     */
    public String authReqForward(String jsonStr, @Context HttpServletRequest req, @Context HttpServletResponse resp) throws Exception {
        resp.setCharacterEncoding("UTF-8");
       String response= new AuthRequest().authRequestExecute(jsonStr);
       System.out.println("二包响应给客户端结果"+response);
        return response;
    }







}