package com.fri.http.legalchapter.rzfw.data;

import java.util.Arrays;
import java.util.regex.Matcher;
import java.util.regex.Pattern;


import cn.com.jit.assp.css.client.util.Base64;
import cn.com.jit.assp.dsign.DSign;
import com.fri.http.legalchapter.rzfw.utils.Constans;
import com.fri.http.legalchapter.rzfw.utils.FormatBytesUtil;

public class DataSignature {
	public static byte[] signature(byte[] data) {
		DSign dSign = new DSign();
		DSign.init("./config/cssconfig.properties");
		String signResultString = dSign.p1Sign(Constans.strDN, Constans.strDigestAlg, data);
		byte[] signResultByte = Base64.decode(signResultString);
		return signResultByte;
	}

	public static boolean signCheck(byte[] dataPackage) {
		byte[] dataLengthByte = Arrays.copyOfRange(dataPackage, 6, 10);
		// 数据区长度
		int dataLength = FormatBytesUtil.getIntFromBytes(dataLengthByte);
		// 被签名数据
		byte[] data = Arrays.copyOfRange(dataPackage, 0, 10 + dataLength);
		// 签名长度数据
		byte[] signatureLengthByte = Arrays.copyOfRange(dataPackage, 10 + dataLength, 11 + dataLength);
		// 签名长度
		int signatureLength = signatureLengthByte[0];
		// 签名数据
		byte[] signatureByte = Arrays.copyOfRange(dataPackage, 11 + dataLength, 11 + dataLength + signatureLength);
		// 证书
		byte[] zhengshu = Arrays.copyOfRange(data, data.length - 32, data.length);
		DSign ds = new DSign();
		DSign.init("./config/cssconfig.properties");
		String certID = new String(zhengshu).trim();
		System.out.println("证书序列号：" + certID);
		String strDigetsAlg = "sm3";
		long a = ds.p1Verify(certID, strDigetsAlg, Base64.encode(signatureByte), data);
		if (a == 0) {
			return true;
		}
		return false;
	}
}
